with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ExtAbstractInterfaceDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 8, 14);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (91, 42, 50, 58);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (27, 64, 88, 78);

   G : constant array (0 .. 92) of Unsigned_8 :=
     (2, 28, 0, 0, 0, 0, 0, 3, 0, 0, 0, 37, 0, 18, 30, 0, 27, 34, 0, 32, 42,
      37, 0, 43, 0, 0, 42, 0, 3, 3, 39, 32, 0, 30, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 8, 3, 30, 4, 0, 0, 0, 0, 15, 0, 0, 0, 31, 0, 0, 13, 25, 16, 26,
      0, 0, 34, 38, 0, 0, 1, 0, 44, 31, 25, 15, 0, 0, 11, 36, 0, 16, 44, 0,
      0, 24, 32, 0, 38, 7, 12, 0, 1, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 93;
         F2 := (F2 + Natural (T2 (K)) * J) mod 93;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 46;
   end Hash;

end CORBA_Repository_Root_ExtAbstractInterfaceDef_Hash;
